	.286
cseg	segment
	assume	cs:cseg,ss:cseg,ds:cseg
	org	80h
command_line_length	label	byte
	org	81h
command_line	label	byte
	org	100h
start:	jmp	main

OUT_W	macro	p1,p2,p3
	push	ax
	push	dx
	mov	dx,p1
	mov	ah,p3
	mov	al,p2
	out	dx,ax
	pop	dx
	pop	ax
	endm

Read_number	macro	Number
	local	rn0,rn1
	xor	dx,dx
	xor	ah,ah
rn0:	lodsb
	cmp	al,'0'
	jb	rn1
	cmp	al,'9'
	ja	rn1
	push	ax
	shl	dx,1
	mov	ax,dx
	shl	dx,1
	shl	dx,1
	add	dx,ax
	pop	ax
	sub	al,'0'
	add	dx,ax
	jmp	rn0
rn1:	mov	Number,dx
	endm

Load	macro	fil_nam,buf_adr
	local	l1,l2
	pusha
	mov	ax,3d00h
	lea	dx,fil_nam
	int	21h
	jnc	l1
	jmp	exit
l1:	mov	bx,ax
	mov	ah,3fh
	lea	dx,buf_adr
	mov	cx,length buf_adr
	int	21h
	jnc	l2
	jmp	exit
l2:	mov	di,ax
	mov	byte ptr buf_adr[di],0
	mov	ah,3eh
	int	21h
	popa
	endm

pset	proc	near
; pset(x,y),color in current video-page (2nd write-mode)
;	cx/dx - x/y
;	al - color
	push	ax
	push	cx
	push	dx
	push	di
	push	es
	mov	di,0a000h
	mov	es,di
	
	mov	di,cx
	mov	ah,80h
	and	cl,7
	shr	ah,cl

	mov	cl,3
	shr	di,cl		; [x/8]
	inc	cl
	shl	dx,cl		; y*16
	mov	cx,dx
	shl	cx,1
	shl	cx,1
	add	dx,cx		; y*80
	add	di,dx		; +x (di - p  p)
	OUT_W	3ceh,8,ah	; . ᪨ ⮢
	mov	ah,es:[di]
	stosb
	pop	es
	pop	di
	pop	dx
	pop	cx
	pop	ax
pset_ex:ret
pset	endp

test_of_read_next_part	proc	near
	push	ax
	lea	ax,PCX_Buffer
	add	ax,length PCX_Buffer
	cmp	si,ax
	jb	rnp

	pusha

	mov	cx,length PCX_Buffer ; ᨬ쭠 
	lea	dx,PCX_Buffer
	mov	ah,3fh
	mov	bx,fm
	int	21h		; p㧪  PCX-䠩

	popa
	lea	si,PCX_Buffer

rnp:	pop	ax
	ret
test_of_read_next_part	endp

regs_load	proc	near
;	(bl):=bh
	push	ax		; p楤p  p㧪
	push	dx		; pp p (p bl)
	mov	dx,3dah		;  梥  bh
	in	al,dx
	mov	al,bl
	mov	dx,3c0h
	out	dx,al
	mov	al,bh
	out	dx,al	
	mov	dx,3dah
	in	al,dx
	mov	dx,3c0h
	mov	al,20h
	out	dx,al	
	pop	dx
	pop	ax
	ret
regs_load	endp

palette_decoding	proc	near
	pusha

	lea	si,PCX_Head
	add	si,16		; si - p p  

	mov	cx,16		; pp p 
	xor	bl,bl		; ⥪饩 p⨭  
palloop:
	xor	bh,bh		;  R - 
	lodsb
	test	al,40h		; p 6-  3- 
	jz	pal1
	or	bh,20h		; ⠭ r
pal1:	test	al,80h
	jz	pal2
	or	bh,4		; ⠭ R
pal2:	lodsb			;  G - 
	test	al,40h
	jz	pal3
	or	bh,10h		; ⠭ g
pal3:	test	al,80h
	jz	pal4
	or	bh,2		; ⠭ G
pal4:	lodsb			;  B - 
	test	al,40h
	jz	pal5
	or	bh,8		; ⠭ b
pal5:	test	al,80h
	jz	pal6
	or	bh,1		; ⠭ B
	
pal6:	call	regs_load	; p㧪 p pp
	inc	bl		; p
	loop	palloop

	popa
	ret
palette_decoding	endp

pcxout	proc	near
	pusha
	push	es

	lea	bx,PCX_Head	;  bx p  PCX-䠩

	mov	ax,maxY		; ᫥ pp
	cmp	[bx+10],ax
	jle	cont33
	mov	[bx+10],ax
	jmp	cont44

cont33:	mov	ax,[bx+10]
cont44:	mov	ax,[bx+4]
	and	al,7
	mov	DeltaB1,al	; DeltaB1:=Xmin mod 8

	mov	ax,[bx+8]
	not	al
	and	al,7
	mov	DeltaB2,al	; DeltaB2:=(7-Xmax) mod 8

	mov	al,0ffh
	mov	cl,DeltaB1
	shr	al,cl
	mov	MaskaLeft,al	; MaskaLeft:=(00..01..11)
				;	      
	mov	al,0ffh		;	     DeltaB1
	mov	cl,DeltaB2
	shl	al,cl
	mov	MaskaRight,al	; MaskaRight:=(11..100..0)
				;		    
	mov	ax,[bx+4]	;		   DeltaB2
	mov	cl,3
	shr	ax,cl
	mov	ah,al		; p   p⨭  ah
	mov	LeftByte,al	; ᫮  ⮢ ᫥ ([Xmin/8])

	mov	dx,[bx+8]
	mov	cl,3
	shr	dx,cl		; RightByte
	xor	dh,dh		; ᫨ p  p  
	sub	dl,al		; p ⮢ p⨭  
	cmp	dx,[bx+66]	; /,  
	jl	cont88		; Bytes:=/,
	mov	dx,[bx+66]
	jmp	cont888
cont88:	inc	dl		;  Bytes:=᫮  p
cont888: mov	Bytes,dl	;    p  (-)

;------------------------------
;	cl - current_card
;	ch - current_byte_count
;	ah - current_byte
;	si - RunLenght_Data
;	bp - BytePerLine
;	Maska_flag - maska_flag
;	Plus_current_x - current_x
	lea	si,PCX_Buffer	; 砫 p 

	mov	bp,[bx+66]	; BytePerLine
	mov	di,[bx+6]	; Ymin
	mov	cl,4
	shl	di,cl
	mov	ax,di
	shl	di,1
	shl	di,1
	add	di,ax
	mov	al,LeftByte
	xor	ah,ah
	add	di,ax		; 80*Ymin+LeftByte

	xor	cx,cx		; current_byte_count & current_card
	mov	ax,[bx+6]
	mov	Plus_current_y,ax
	mov	dx,Pages
	mov	es,dx
	jmp	kk21

kk1:	inc	cl		; ᫥ p
	cmp	cl,4
	jne	kk2
	xor	cl,cl
	inc	Plus_current_y
	push	ax
	mov	ax,Plus_current_y
	cmp	ax,[bx+10]
	pop	ax
	jbe	kk11		; 
	jmp	kk5

kk11:	add	di,80
kk2:	xor	dx,dx
	push	cx

kkk0:	or	cl,cl
	jz	kkk
	add	dx,0a00h
	dec	cl
	jmp	kkk0

kkk:	add	dx,Pages
	mov	es,dx
	pop	cx

	sub	di,bp		;  ᫮   

kk21:	mov	Plus_current_x,0; current_x
	mov	Maska_flag,0	; 䫠  ⠭ ᪨
	jmp	next_byte

kk3:	jmp	next_byte

kk4:
next_byte:
	cmp	ch,0		; current_byte_count
	jne	next_ex

	call	test_of_read_next_part
	lodsb			;  al ᫥騩 RunLength - 

	cmp	al,0c0h		; ᫨ 7-  6-  ⠭,
	jnb	nm2		;     (᫠ p
				; ᫥饣  ( ))
nm1:	mov	ah,al		;   
	mov	ch,1		;  
	jmp	next_ex

nm2:	and	al,3fh		;    (   6 )
	mov	ch,al		; ⮫쪮 p

	call	test_of_read_next_part
	lodsb			;  al ᫥騩 RunLength - 

	mov	ah,al		; p塞  

next_ex:
	mov	al,ah		;  
	stosb			;  ᫥饣   -

	dec	ch		; dec current_byte_count
	inc	Plus_current_x	; current_x

	mov	dl,Plus_current_x
	inc	dl
	cmp	dl,Bytes	; Bytes
	je	kk4
	jb	kk44

kk44:	cmp	dl,[bx+66]	; BytePerLine
	jbe	kk45
	jmp	kk1

kk45:	cmp	Maska_flag,0
	jne	next_byte

	inc	Maska_flag
	jmp	kk3

kk5:	mov	bx,fm
	mov	ah,3eh
	int	21h
	
;	cmp	first_flag,0
;	je	po2
	call	palette_decoding
;	mov	first_flag,0

po2:	OUT_W	3ceh,5,0
	OUT_W	3ceh,8,0ffh
	mov	cx,4
	mov	dx,0a000h
	mov	es,dx
	mov	dx,Pages
	push	ds
	mov	ds,dx
	
po1:	push	cx
	neg	cl
	add	cl,4
	mov	al,1
	shl	al,cl
	OUT_W	3c4h,2,al
	xor	si,si
	xor	di,di
	mov	cx,80*480
	rep	movsb
	add	dx,0a00h
	mov	ds,dx
	pop	cx
	loop	po1
	
	pop	ds
	pop	es
	popa
	ret
pcxout	endp

Box	proc	near
	mov	cx,X1
	mov	di,cx
	add	di,X_size1
	mov	dx,Y1
	sub	cx,2
	sub	dx,2
	mov	bp,Y_size1
	add	bp,4
	
b1:	push	cx
	mov	al,0
	call	pset
	inc	cx
	mov	al,15
	call	pset
	mov	cx,di
	mov	al,8
	call	pset
	inc	cx
	mov	al,0
	call	pset
	inc	dx
	pop	cx
	dec	bp
	jnz	b1
	
	mov	cx,X1
	mov	dx,Y1
	mov	di,dx
	add	di,Y_size1
	dec	cx
	dec	dx
	mov	bp,X_size1
	add	bp,2
	
b2:	push	dx
	mov	al,15
	call	pset
	dec	dx
	mov	al,0
	call	pset
	mov	dx,di
	mov	al,8
	call	pset
	inc	dx
	mov	al,0
	call	pset
	inc	cx
	pop	dx
	dec	bp
	jnz	b2
	
	push	es
	mov	ax,0a000h
	mov	es,ax
	OUT_W	3ceh,8,0ffh	; . ᪨ ⮢
	mov	di,X
	mov	dx,Y1
	mov	cl,4
	shl	dx,cl		; y*16
	mov	cx,dx
	shl	cx,1
	shl	cx,1
	add	dx,cx		; y*80
	add	di,dx		; +x (di - p  p)
	mov	dx,di
	mov	al,7
	mov	cx,Y_size1

b3:	push	cx
	mov	cx,X_size
	mov	di,dx
	
b4:	mov	ah,es:[di]
	stosb
	loop	b4
	
	add	dx,80
	pop	cx
	loop	b3

	pop	es
	ret
Box	endp

Out_text	proc	near
	push	es
	mov	ax,0a000h
	mov	es,ax
	mov	di,X
	mov	dx,Y1
	mov	cl,4
	shl	dx,cl		; y*16
	mov	cx,dx
	shl	cx,1
	shl	cx,1
	add	dx,cx		; y*80
	add	di,dx		; +x (di - p  p)
	mov	al,80
	mul	byte ptr Symbol_high
	mov	dx,ax ; ࠧ  -  ᥤ  ⨪ ᨬ
add	di,dx
add	di,2
	mov	bp,di
	
ot1:	lodsb
	cmp	al,13
	je	ot2
	push	si
	xor	ah,ah
	mul	byte ptr Symbol_high
	lea	si,Font_Buffer
	add	si,ax
	mov	cx,Symbol_high
	
	ot3:	lodsb
		OUT_W	3ceh,8,al	; . ᪨ ⮢
		mov	al,0
		mov	ah,es:[di]
		mov	es:[di],al
		add	di,80
		loop	ot3
	
	sub	di,dx
	inc	di
	pop	si
	jmp	ot1

ot2:	cmp	di,bp
	je	ot_ex
	inc	si
	add	bp,dx
	mov	di,bp
	jmp	ot1
	
ot_ex:	pop	es
	ret
Out_text	endp

Commentary	proc	near
	Read_number	X1
	Read_number	Y1
	mov	dx,X1
	and	dx,0fff8h
	mov	X1,dx
	mov	cl,3
	shr	dx,cl
	mov	X,dx
	Read_number	Wait_time
	mov	al,byte ptr Wait_time
	mov	ah,18
	mul	ah
	mov	Wait_time,ax
	inc	si

	mov	di,si		; ࠭ 㪠⥫  Out_text
	xor	bx,bx		; ᫮ 祪 ⥪
	xor	dx,dx		; ᨬ쭠  窨

comm0:	xor	cx,cx		; ⥪  窨
	
comm1:	lodsb
	cmp	al,13
	je	comm2
	inc	cx
	jmp	comm1

comm2:	or	cx,cx
	jz	comm3
	inc	si
	inc	bx
	cmp	cx,dx
	jle	comm0
	mov	dx,cx
	jmp	comm0
	
comm3:	inc	si
	or	bx,bx
	jz	comm_ex
	mov	bp,si		; . -  ⥭ ᫥-  䠩
	mov	si,di		; - 㪠⥫
add	dx,4
add	bx,2
	mov	X_size,dx
	mov	Y_size,bx
	mov	cl,3
	shl	dx,cl
	mov	X_size1,dx
	mov	ax,Symbol_high
	mul	bx
	mov	Y_size1,ax
	OUT_W	3ceh,5,2
	OUT_W	3ceh,8,0ffh
	OUT_W	3c4h,2,1111b
	pusha
	call	Box
	call	Out_text
	popa
	mov	si,bp		; - -  ⥭ ᫥-  䠩

comm_ex:ret
Commentary	endp

Next_file	proc	near
	lea	dx,file_name
	mov	ax,3d00h
	int	21h
	jc	nf_ex
	
	mov	fm,ax
	mov	ah,3fh
	lea	dx,PCX_Head
	mov	cx,length PCX_Buffer
	add	cx,128
	mov	bx,fm
	int	21h

	call	pcxout
	call	Commentary

nf_ex:	ret
Next_file	endp

Demo	proc	near
	mov	ax,12h
	int	10h
	
	Load	font_name,Font_Buffer
	Load	demo_name,Demo_Buffer
	lea	si,Demo_Buffer

d0:	lea	di,file_name
	
d1:	lodsb
	or	al,al
	jz	demo_ex
	cmp	al,' '
	je	d2
	stosb
	jmp	d1

d2:	xor	al,al
	stosb
	
	call	Next_file
	cmp	Wait_time,0
	je	d3
	xor	ah,ah
	int	1ah
	add	dx,Wait_time
	mov	bx,dx
	
d4:	mov	ah,1
	int	16h
	jnz	d3
	xor	ah,ah
	int	1ah
	cmp	dx,bx
	jb	d4
	jmp	d0
	
d3:	xor	ax,ax
	int	16h
	cmp	ax,11bh
	je	demo_ex
	jmp	d0
	
demo_ex:ret
Demo	endp

;------------------------------------------------------------------------------
;------------------------------------------------------------------------------
;----------------------- M A I N -- P R O G R A M -----------------------------
;------------------------------------------------------------------------------
main:	cld
	mov	ah,4ah
	mov	bx,1000h
	int	21h
	jc	ex
	mov	ah,48h
	mov	bx,4*0a00h
	int	21h
	jc	ex
	mov	Pages,ax
	
	call	Demo

exit:	mov	ax,3
	int	10h
	mov	ax,Pages
	mov	es,ax
	mov	ah,49h
	int	21h

ex:	int	20h	; QUIT

;------------------------------ D A T A ---------------------------------------
; ᭮   pp
;---------------------------- p㣨  -----------------------------------
; p  裡  譨 p (᪮)
demo_name	db	'demomake.txt',0
font_name	db	'demomake.fnt',0
file_name	db	100 dup(?)
fm	dw	?
error_flag	db	0

; p p  p᪮ 뢮
maxX	equ	639
maxY	equ	479
Symbol_high	dw	16
Wait_time	dw	?
X	dw	?	;  ᨬ
X_size	dw	?
Y_size	dw	?
X1	dw	?	;  ᥫ
Y1	dw	?
X_size1	dw	?
Y_size1	dw	?
Pages	dw	?	;  ࠭ ⨭  
first_flag	db	1

; After PCXOut
DeltaX		dw	(?)
DeltaY		dw	(?)
DeltaB1		db	(?)
DeltaB2		db	(?)
LeftByte	db	(?)
Bytes		db	(?)
RightByte	db	(?)
MaskaLeft	db	(?)
MaskaMedium	db	0ffh
MaskaRight	db	(?)
; ᯮ⥫ p
Plus_current_x	db	?
Plus_current_y	dw	?
Maska_flag	db	?

;---------------------------- DIFFERENT BUFFERS -------------------------------
;----------------------------- PCX-data buffer --------------------------------
;	Begin(3db),Bits(db),Xmin(dw),Ymin(dw),Xmax(dw),Ymax(dw)
;	HRes(dw),VRes(dw),Palette(16*3db),db,Planes(db)
;	BytePerLine(dw),PaletteInfo(dw)
PCX_Head	db	128 dup(?)	;  PCX-䠩
PCX_Buffer	db	50000 dup(?)	; p 뢠 䠩
Demo_Buffer	db	5000 dup(?)	;   -
Font_Buffer	db	5000 dup(?)	;   
cseg	ends
	end	start
